# Roo Code 3.16.1 Release Notes (2025-05-07)

This release introduces LiteLLM provider support for more AI backend options, improved stability by detecting and preventing tool execution loops, Dutch localization, enhanced telemetry by including the editor name, a UI migration to Tailwind CSS for better consistency (temporarily reverted in v3.16.3), a fix for responsive footer buttons, updated evaluation defaults, and the latest dependency versions for improved security and performance.

## New Provider: LiteLLM Integration
We've introduced support for the [LiteLLM provider](/providers/litellm), simplifying access to a wide array of language models. This new integration offers:
*   **Automatic Model Discovery**: Roo Code automatically fetches and lists available models from your LiteLLM server. This means users no longer need to manually configure each LiteLLM model within Roo Code, streamlining setup and making it easier to switch between models served by LiteLLM.
*   **Simplified Access to 100+ LLMs**: Leverage LiteLLM's ability to provide a unified OpenAI-compatible API for various underlying models.

<img src="/img/litellm/litellm.png" alt="Roo Code LiteLLM Provider Settings" width="600" />

This new provider significantly improves the ease of using diverse models through LiteLLM. For more details on setting up LiteLLM, see the [LiteLLM provider documentation](/providers/litellm).

## Tool Loop Detection
We've implemented a mechanism to detect and prevent tool execution loops, enhancing stability and user experience:
*   **Prevents Infinite Loops**: The system now identifies when a tool might be caught in a repetitive cycle and intelligently intervenes by prompting for user input.
*   **Improved Stability**: Reduces the risk of the application becoming unresponsive or stuck due to unintentional tool looping.

This ensures a smoother, more reliable, and frustration-free interaction with the extension's tools.

## QOL Improvements
*   **Dutch Localization Added**: Added Dutch language support, allowing Dutch-speaking users to use the extension in their native language for a more inclusive experience. (thanks Githubguy132010!)
*   **Tailwind CSS Migration**: Migrated the UI to Tailwind CSS for a more polished and cohesive interface. (Note: This was reverted in v3.16.3)
*   **Responsive Footer Buttons in About Section**: Fixed the layout of footer buttons in the About section, ensuring they wrap correctly on narrow screens for a better mobile experience and improved accessibility. (thanks ecmasx!)

## Misc Improvements
*   **Editor Name in Telemetry**: Added the editor name to telemetry data. This helps in understanding which editors are most used and enables more targeted improvements and support for different environments.
*   **Improved Evaluation Defaults and Setup**: Updated evaluation defaults and improved the setup process, making the evaluation environment easier and more reliable to configure with more practical out-of-the-box settings.
*   **Update Dependencies**: Updated dependencies to their latest versions for improved security and performance.